"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.buildObjTree = exports.buildArrTree = void 0;
/**
 * 生成树状结构数组,参考buildObjTree
 * Generates an array of tree structures, refer to BuildoBJTree
 * @param list
 * @param id
 * @param pid
 * @returns
 */
function buildArrTree(list, id = 'id', pid = 'pid') {
    let temp = {}, tree = [];
    for (let i in list) {
        temp[list[i][id]] = list[i];
    }
    for (let i in temp) {
        if (temp[i][pid] && temp[temp[i][pid]]) {
            if (!temp[temp[i][pid]].children) {
                temp[temp[i][pid]].children = [];
            }
            temp[temp[i][pid]].children.push(temp[i]);
        }
        else {
            tree.push(temp[i]);
        }
    }
    return tree;
}
exports.buildArrTree = buildArrTree;
/**
 * @function Array members with id and parent id are generated into a tree structure
 * @function 具有id和父id对象的数组生成为树结构
 * @param list 具有id和父id对象组成的数组
 * @param id 设置对象id属性的名称
 * @param pid 设置对象父id属性的名称
 * @param list An array of id and parent id objects
 * @param id Sets the name of the object ID property
 * @param pid Sets the name of the object's parent ID property
 * @returns TreeObj
 */
function buildObjTree(list, id = 'id', pid = 'pid') {
    let temp = {}, tree = {};
    for (let i in list) {
        temp[list[i][id]] = list[i];
    }
    for (let i in temp) {
        if (temp[i][pid] && temp[temp[i][pid]]) {
            if (!temp[temp[i][pid]].children) {
                temp[temp[i][pid]].children = new Object();
            }
            temp[temp[i][pid]].children[temp[i][id]] = temp[i];
        }
        else {
            tree[temp[i][id]] = temp[i];
        }
    }
    return tree;
}
exports.buildObjTree = buildObjTree;
