"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports._getWindowTransparency = exports._cancelWindowTransparency = exports._setWindowTransparency = exports._findWindowFuzzy = exports._modifyStyleEx = exports._modifyStyle = exports.EnumChildWindows = exports.EnableWindow = exports.GetWindow = exports.GetWindowHicon = exports.SetClassLongPtrA = exports.GetClassLongPtrA = exports.GetClassName = exports.IsZoomed = exports.IsWindowUnicode = exports.IsWindowVisible = exports.IsWindowEnabled = exports.GetWindowThreadProcessId = exports.EnumDesktopWindows = exports.GetForegroundWindow = exports.GetLastError = exports.GetDesktopWindow = exports.EnumWindows = exports.GetWindowInfo = exports.IsWindow = exports.WindowFromPoint = exports.SetForegroundWindow = exports.GetWindowText = exports.SendMessageA = exports.PostMessageA = exports.ShowWindow = exports.GetLayeredWindowAttributes = exports.SetWindowPos = exports.SetLayeredWindowAttributes = exports.GetWindowLongPtrA = exports.SetWindowLongPtrA = exports.ShowCursor = exports.GetCursorInfo = exports.GetClipCursor = exports.ClipCursor = exports.GetAncestor = exports.UpdateWindow = exports.GetWindowRect = exports.GetClientRect = exports.FindWindowExA = exports.FindWindowA = exports.GetDpiForSystem = exports.GetDpiForWindow = exports.SWP = exports.GWL = void 0;
exports._isTransparency = exports._isTopMost = exports._windowFromCursorPoint = exports._setWindowTopmost = void 0;
//@ts-ignore
const nwinuser_node_1 = __importDefault(require("../../nwinuser.node"));
exports.GWL = {
    EXSTYLE: -20,
    HINSTANCE: -6,
    HWNDPARENT: -8,
    ID: -12,
    STYLE: -16,
    USERDATA: -21
};
exports.SWP = {
    ASYNCWINDOWPOS: 0x4000,
    DEFERERASE: 0x2000,
    DRAWFRAME: 0x0020,
    FRAMECHANGED: 0x0020,
    HIDEWINDOW: 0x0080,
    NOACTIVATE: 0x0010,
    NOCOPYBITS: 0x0100,
    NOMOVE: 0x0002,
    NOOWNERZORDER: 0x0200,
    NOREDRAW: 0x0008,
    NOSENDCHANGING: 0x0400,
    NOSIZE: 0x0001,
    NOZORDER: 0x0004,
    SHOWWINDOW: 0x0040,
};
/**
 * @function 获取窗口DPI
 */
function GetDpiForWindow(hWnd) {
    //test:ok
    return nwinuser_node_1.default.GetDpiForWindow(hWnd);
}
exports.GetDpiForWindow = GetDpiForWindow;
/**
 * @function 获取系统DPI
 */
function GetDpiForSystem() {
    //test:ok
    return nwinuser_node_1.default.GetDpiForSystem();
}
exports.GetDpiForSystem = GetDpiForSystem;
/**
 * @function 寻找窗口
 * @param className 窗口类名,为空则返回第一个与类名匹配的窗口
 * @param className "" returns the first window that matches the className
 * @param windowName 窗口标题,为空则返回第一个与标题匹配的窗口
 * @param windowName "" returns the first window that matches the windowName
 * @returns hWnd 窗口句柄
 */
function FindWindowA(className = "", windowName = "") {
    //test:ok
    return nwinuser_node_1.default.FindWindowA(className.trim(), windowName.trim());
}
exports.FindWindowA = FindWindowA;
/**
 * @function 寻找窗口
 * @param hWndParent 为0等同于C++null
 * @param hWndParent 0 equals C++ NULL
 * @param hWndChildAfter 为0等同于C++null
 * @param hWndChildAfter 0 equals C++ NULL
 * @param className 窗口类名,为空则返回第一个与类名匹配的窗口
 * @param className "" returns the first window that matches the className
 * @param windowName 窗口标题,为空则返回第一个与标题匹配的窗口
 * @param windowName "" returns the first window that matches the windowName
 * @returns hWnd 窗口句柄
 */
function FindWindowExA(hWndParent, hWndChildAfter, className, WindowName) {
    //test:ok
    return nwinuser_node_1.default.FindWindowExA(hWndParent, hWndChildAfter, className.trim(), WindowName.trim());
}
exports.FindWindowExA = FindWindowExA;
/**
 * @function 获取客户区矩形
 * @param hWnd
 * @returns 返回矩形，失败返回null
 * @returns Returns a rectangle. Failure returns null
 */
function GetClientRect(hWnd) {
    //test:ok
    return nwinuser_node_1.default.GetClientRect(hWnd);
}
exports.GetClientRect = GetClientRect;
/**
 * @function 获取窗口矩形
 * @param hWnd
 * @returns 返回矩形，失败返回null
 * @returns Returns a rectangle. Failure returns null
 */
function GetWindowRect(hWnd) {
    //test:ok
    return nwinuser_node_1.default.GetWindowRect(hWnd);
}
exports.GetWindowRect = GetWindowRect;
/**
 * @function 更新窗口,成功返回真，反之。
 * @param hWnd
 */
function UpdateWindow(hWnd) {
    // test:ok
    return nwinuser_node_1.default.UpdateWindow(hWnd);
}
exports.UpdateWindow = UpdateWindow;
/**
 *
 * @param hWnd
 * @param gaFlags The ancestor to be retrieved.
 * @param gaFlags 要检索的祖先。
 */
function GetAncestor(hWnd, gaFlags) {
    //test:ok
    return nwinuser_node_1.default.GetAncestor(hWnd, gaFlags);
}
exports.GetAncestor = GetAncestor;
/**
 * @function Limit mouse area
 * @function 限制鼠标区域
 * @param Rect null为解除
 */
function ClipCursor(Rect) {
    //test:ok
    return nwinuser_node_1.default.ClipCursor(Rect);
}
exports.ClipCursor = ClipCursor;
/**
 * @function 取限制区矩形
 */
function GetClipCursor() {
    //test:ok
    return nwinuser_node_1.default.GetClipCursor();
}
exports.GetClipCursor = GetClipCursor;
/**
 * @function 获取鼠标详情(位置,是否隐藏,指针句柄)
 */
function GetCursorInfo() {
    //test:ok
    return nwinuser_node_1.default.GetCursorInfo();
}
exports.GetCursorInfo = GetCursorInfo;
/**
 *  @function 当前进程下窗口隐藏或显示鼠标(electron也可以cursor:none给元素设置)
 *  @function Hide or show mouse in current process window (electron can also be set to cursor:none for elements)
 */
function ShowCursor(bShow) {
    return nwinuser_node_1.default.ShowCursor(bShow);
}
exports.ShowCursor = ShowCursor;
/**
 *
 * @param hWnd
 * @param nIndex GWL_常量
 * @param dwNewLong
 * @return If the function succeeds, the return value is the requested value. And vice versa is zero.
 * @return 如果函数成功，返回值就是请求值。反之为零。
 */
function SetWindowLongPtrA(hWnd, nIndex, dwNewLong) {
    //test:ok
    return nwinuser_node_1.default.SetWindowLongPtrA(hWnd, nIndex, dwNewLong);
}
exports.SetWindowLongPtrA = SetWindowLongPtrA;
function GetWindowLongPtrA(hWnd, nIndex) {
    //test:ok
    return nwinuser_node_1.default.GetWindowLongPtrA(hWnd, nIndex);
}
exports.GetWindowLongPtrA = GetWindowLongPtrA;
/**
 * @function 设置窗口透明度，需要设置扩展样式WS_EX_LAYERED
 * @function The extension style WS EX LAYERED needs to be set
 * @param hWnd
 * @param colorKey 颜色值
 * @param alpha  0 completely transparent,255 completely opaque
 * @param alpha  0完全透明,255完全不透明
 * @param flags
 */
function SetLayeredWindowAttributes(hWnd, colorKey, alpha, flags) {
    //test:ok
    alpha = alpha > 255 ? 255 : alpha < 0 ? 0 : alpha;
    return nwinuser_node_1.default.SetLayeredWindowAttributes(hWnd, colorKey, alpha, flags);
}
exports.SetLayeredWindowAttributes = SetLayeredWindowAttributes;
/**
 * @function 更改窗口的大小,位置
 * @function Change window size, position
 * @param hWnd 窗口句柄
 * @param hWndInsertAfter 该窗口句柄之后或HWND_常量值
 * @param hWndInsertAfter After the window handle or HWND constant value
 * @param X
 * @param Y
 * @param cx 宽度 width
 * @param cy 高度 height
 * @param uFlags 窗口大小和定位标志。SWP_常量值可组合
 */
function SetWindowPos(hWnd, hWndInsertAfter, X, Y, cx, cy, uFlags) {
    //test:ok
    return nwinuser_node_1.default.SetWindowPos(hWnd, hWndInsertAfter, X, Y, cx, cy, uFlags);
}
exports.SetWindowPos = SetWindowPos;
/**
 * @function 获取分层窗口的不透明度和颜色值
 * @function Gets the opacity and color values of the layered window
 * @param hWnd
 */
function GetLayeredWindowAttributes(hWnd) {
    //test:ok
    return nwinuser_node_1.default.GetLayeredWindowAttributes(hWnd);
}
exports.GetLayeredWindowAttributes = GetLayeredWindowAttributes;
/**
 * @function 显示窗口
 * @param hWnd
 * @param CmdShow 显示方式
 */
function ShowWindow(hWnd, CmdShow) {
    //test:ok
    return nwinuser_node_1.default.ShowWindow(hWnd, CmdShow);
}
exports.ShowWindow = ShowWindow;
/**
 * @function 投递消息
 * @param hWnd
 * @param msg 消息值
 * @param wParam
 * @param lParam
 */
function PostMessageA(hWnd, msg, wParam, lParam) {
    //test:ok
    return nwinuser_node_1.default.PostMessageA(hWnd, msg, wParam, lParam);
}
exports.PostMessageA = PostMessageA;
/**
 * @function 发送消息
 * @param hWnd
 * @param msg 消息值
 * @param wParam
 * @param lParam
 */
function SendMessageA(hWnd, msg, wParam, lParam) {
    //test:ok
    return nwinuser_node_1.default.SendMessageA(hWnd, msg, wParam, lParam);
}
exports.SendMessageA = SendMessageA;
/**
 * 取窗口标题
 * @param hWnd
 */
function GetWindowText(hWnd) {
    //test:ok
    return nwinuser_node_1.default.GetWindowText(hWnd);
}
exports.GetWindowText = GetWindowText;
/**
 * 聚焦窗口
 * @param hWnd
 */
function SetForegroundWindow(hWnd) {
    //test:ok
    return nwinuser_node_1.default.SetForegroundWindow(hWnd);
}
exports.SetForegroundWindow = SetForegroundWindow;
/**
 * 取点位置窗口
 * @param x
 * @param y
 */
function WindowFromPoint(x, y) {
    //test:ok
    return nwinuser_node_1.default.WindowFromPoint(x, y);
}
exports.WindowFromPoint = WindowFromPoint;
/**
 * @function 窗口是否有效
 * @param hWnd
 */
function IsWindow(hWnd) {
    //test:ok
    return nwinuser_node_1.default.IsWindow(hWnd);
}
exports.IsWindow = IsWindow;
function GetWindowInfo(hWnd) {
    return nwinuser_node_1.default.GetWindowInfo(hWnd);
}
exports.GetWindowInfo = GetWindowInfo;
/**
 * 具体查看文档EnumWindows，函数调用错误会设置Error。
 * @returns 返回所有顶级窗口。。
 */
function EnumWindows() {
    return nwinuser_node_1.default.EnumWindows();
}
exports.EnumWindows = EnumWindows;
/**
 * 获取桌面句柄
 */
function GetDesktopWindow() {
    //test:ok
    return nwinuser_node_1.default.GetDesktopWindow();
}
exports.GetDesktopWindow = GetDesktopWindow;
/**
 * 获取最后一条错误。
 */
function GetLastError() {
    //test:ok
    return nwinuser_node_1.default.GetLastError();
}
exports.GetLastError = GetLastError;
/**
 * 获取聚焦窗口句柄
 */
function GetForegroundWindow() {
    //test:ok
    return nwinuser_node_1.default.GetForegroundWindow();
}
exports.GetForegroundWindow = GetForegroundWindow;
/**
 * @function EnumDesktopWindows 基于桌面为根基进行枚举窗口
 * @param desktopHwnd 桌面句柄。如果没有提供desktopHwnd,默认为NULL。表示当前桌面。
 */
function EnumDesktopWindows(desktopHwnd = 0) {
    //test:ok
    return nwinuser_node_1.default.EnumDesktopWindows(desktopHwnd);
}
exports.EnumDesktopWindows = EnumDesktopWindows;
/**
 * 取窗口线程ID和进程ID
 * @param hWnd
 */
function GetWindowThreadProcessId(hWnd) {
    //test:ok
    return nwinuser_node_1.default.GetWindowThreadProcessId(hWnd);
}
exports.GetWindowThreadProcessId = GetWindowThreadProcessId;
/**
 * 窗口是否启用，窗口允许接受键盘或鼠标输入返回true，反之。
 * 子窗口只有在被允许并且可见时才可接受输入
 * @param hWnd
 */
function IsWindowEnabled(hWnd) {
    //test:ok
    return nwinuser_node_1.default.IsWindowEnabled(hWnd);
}
exports.IsWindowEnabled = IsWindowEnabled;
/**
 * 窗口是否可见
 * @param hWnd
 */
function IsWindowVisible(hWnd) {
    //test:ok
    return nwinuser_node_1.default.IsWindowVisible(hWnd);
}
exports.IsWindowVisible = IsWindowVisible;
/**
 * 窗口是否为Unicode窗口
 * @param hWnd
 */
function IsWindowUnicode(hWnd) {
    //test:ok
    return nwinuser_node_1.default.IsWindowUnicode(hWnd);
}
exports.IsWindowUnicode = IsWindowUnicode;
/**
 * 窗口是否最大
 * @param hWnd
 */
function IsZoomed(hWnd) {
    //test:ok
    return nwinuser_node_1.default.IsZoomed(hWnd);
}
exports.IsZoomed = IsZoomed;
/**
 * 获取窗口类名
 * @param hWnd
 */
function GetClassName(hWnd) {
    //test:ok
    return nwinuser_node_1.default.GetClassName(hWnd);
}
exports.GetClassName = GetClassName;
function GetClassLongPtrA(hWnd, index) {
    return nwinuser_node_1.default.GetClassLongPtrA(hWnd, index);
}
exports.GetClassLongPtrA = GetClassLongPtrA;
function SetClassLongPtrA(hWnd, index, newLong) {
    return nwinuser_node_1.default.SetClassLongPtrA(hWnd, index, newLong);
}
exports.SetClassLongPtrA = SetClassLongPtrA;
/**
 * 获取窗口图标句柄,使用SendMessageTimeout和GetClassLong,有如果失败会有40ms的延迟
 * 可自行更改获取方式例如单独的GetClassLong
 * @param hWnd
 */
function GetWindowHicon(hWnd) {
    //test:ok
    return nwinuser_node_1.default.GetWindowHicon(hWnd);
}
exports.GetWindowHicon = GetWindowHicon;
/**
 * 获取窗口
 * GW_HWNDFIRST=0
 * GW_HWNDLAST=1
 * GW_HWNDNEXT=2
 * GW_HWNDPREV=3
 * GW_OWNER=4
 * GW_CHILD=5
 * GW_ENABLEDPOPUP=6
 * @param hWnd
 * @param cmd
 */
function GetWindow(hWnd, cmd) {
    return nwinuser_node_1.default.GetWindow(hWnd, cmd);
}
exports.GetWindow = GetWindow;
/**
 * 启用或禁用窗口
 * @param hWnd
 * @param flag
 */
function EnableWindow(hWnd, flag) {
    //test:ok
    return nwinuser_node_1.default.EnableWindow(hWnd, flag);
}
exports.EnableWindow = EnableWindow;
/**
 * @function 枚举窗口的子窗口句柄
 * @function Enumerates the handle to a child window of a window
 * @param ParentHWnd 如果为0，则效果等同于EnumWindows
 * @param ParentHWnd If 0, the effect is equivalent to EnumWindows
 */
function EnumChildWindows(ParentHWnd) {
    //test:ok
    return nwinuser_node_1.default.EnumChildWindows(ParentHWnd);
}
exports.EnumChildWindows = EnumChildWindows;
//-------------------------包装后方法
/**
 * @param flags If it is not zero, call SetWindowPos and redraw the preset flag。
 * SWP.NOSIZE | SWP.NOMOVE | SWP.NOZORDER | SWP.NOACTIVATE
 * @returns Returns true on success, or the window style value before the call
 */
function _modifyStyle(hWnd, { addStyle = 0, removeStyle = 0 } = {}, flags = true) {
    let style = GetWindowLongPtrA(hWnd, exports.GWL.STYLE);
    style = style & ~removeStyle;
    style = style | addStyle;
    let mod = SetWindowLongPtrA(hWnd, exports.GWL.STYLE, style);
    let ok = mod === style, ok2 = true;
    if (flags === true) {
        ok2 = SetWindowPos(hWnd, 0, 0, 0, 0, 0, exports.SWP.NOSIZE | exports.SWP.NOMOVE | exports.SWP.NOZORDER | exports.SWP.NOACTIVATE);
    }
    else if (typeof flags == "number") {
        ok2 = SetWindowPos(hWnd, 0, 0, 0, 0, 0, exports.SWP.NOSIZE | exports.SWP.NOMOVE | exports.SWP.NOZORDER | exports.SWP.NOACTIVATE | flags);
    }
    if (!(ok && ok2)) {
        return true;
    }
    return style;
}
exports._modifyStyle = _modifyStyle;
/**
 * @param flags If it is not zero, call SetWindowPos and redraw the preset flag。
 * SWP.NOSIZE | SWP.NOMOVE | SWP.NOZORDER | SWP.NOACTIVATE
 * @returns Returns true on success, or the window style value before the call
 */
function _modifyStyleEx(hWnd, { addStyle = 0, removeStyle = 0 } = {}, flags = 0) {
    let style = GetWindowLongPtrA(hWnd, exports.GWL.EXSTYLE);
    style = style & ~removeStyle;
    style = style | addStyle;
    let mod = SetWindowLongPtrA(hWnd, exports.GWL.EXSTYLE, style);
    let ok = mod === style, ok2 = true;
    if (flags === true) {
        ok2 = SetWindowPos(hWnd, 0, 0, 0, 0, 0, exports.SWP.NOSIZE | exports.SWP.NOMOVE | exports.SWP.NOZORDER | exports.SWP.NOACTIVATE);
    }
    else if (typeof flags == "number") {
        ok2 = SetWindowPos(hWnd, 0, 0, 0, 0, 0, exports.SWP.NOSIZE | exports.SWP.NOMOVE | exports.SWP.NOZORDER | exports.SWP.NOACTIVATE | flags);
    }
    if (!(ok && ok2)) {
        return true;
    }
    return style;
}
exports._modifyStyleEx = _modifyStyleEx;
/**
 * @function Fuzzy search window
 * @param windowName Part of the window title to search, regardless of case
 * @param className The class name must be written in full, emptyString Ignore
 * @function 模糊搜索窗口
 * @param windowName 要搜索的窗口部分窗口标题,无视大小写
 * @param className 类名必须写明,空文本则忽略
 */
function _findWindowFuzzy(windowName, className = "") {
    let _hWnd = 0;
    let _title = "";
    while (true) {
        _hWnd = FindWindowExA(0, _hWnd, className, '');
        if (_hWnd != 0) {
            _title = GetWindowText(_hWnd).toLocaleLowerCase();
            if (_title.includes(windowName)) {
                return _hWnd;
            }
        }
        else {
            break;
        }
    }
    return 0;
}
exports._findWindowFuzzy = _findWindowFuzzy;
//#region 透明相关
/**
 * @function 设置窗口透明度
 * @param hWnd
 * @param alpha 不透明值,0完全透明,255完全不透明
 * @param through 窗口是否可穿透
 * @param colorKey
 */
function _setWindowTransparency(hWnd, alpha, through = false, colorKey = false) {
    _modifyStyleEx(hWnd, { addStyle: through ? 524288 | 32 : 524288 });
    let method = 1;
    if (colorKey === false) {
        method = 2;
        colorKey = 0;
    }
    return SetLayeredWindowAttributes(hWnd, colorKey, alpha, method);
}
exports._setWindowTransparency = _setWindowTransparency;
/**
 * @function 取消窗口透明,返回真成功否则返回之前样式值.
 * @function Cancel window transparency, return true success otherwise return previous style value.
 * @param hWnd
 */
function _cancelWindowTransparency(hWnd) {
    return _modifyStyleEx(hWnd, { removeStyle: 524288 | 32 });
}
exports._cancelWindowTransparency = _cancelWindowTransparency;
/**
 * 获取窗口不透明度,只有调用SetLayeredWindowAttributes后才会正确返回
 * 调用upLayeredWindowAttributes后失效
 * @param hWnd
 */
function _getWindowTransparency(hWnd) {
    let _r = GetLayeredWindowAttributes(hWnd);
    if (_r) {
        return _r.alpha;
    }
    return false;
}
exports._getWindowTransparency = _getWindowTransparency;
//#endregion
/**
 * @function 置顶窗口
 * @function topmost window
 * @param hWnd
 * @param topmost
 */
function _setWindowTopmost(hWnd, topmost = true) {
    if (topmost) {
        SetForegroundWindow(hWnd);
        return SetWindowPos(hWnd, -1, 0, 0, 0, 0, exports.SWP.NOMOVE | exports.SWP.NOSIZE);
    }
    else {
        return SetWindowPos(hWnd, -2, 0, 0, 0, 0, exports.SWP.NOMOVE | exports.SWP.NOSIZE);
    }
}
exports._setWindowTopmost = _setWindowTopmost;
/**
 * @function 取鼠标位置处窗口句柄
 * @function Gets the window handle at the mouse position
 */
function _windowFromCursorPoint() {
    let c = GetCursorInfo();
    return WindowFromPoint(c.ptScreenPos.x, c.ptScreenPos.y);
}
exports._windowFromCursorPoint = _windowFromCursorPoint;
/**
 * 取窗口是否顶置
 * @param hWnd
 */
function _isTopMost(hWnd) {
    let info = GetWindowInfo(hWnd);
    if (info) {
        return info.dwExStyle & 8;
    }
    return false;
}
exports._isTopMost = _isTopMost;
/**
 * 窗口是否添加分层特效。
 */
function _isTransparency(hWnd) {
    //test:ok
    let info = GetWindowInfo(hWnd);
    if (info) {
        return info.dwExStyle & 524288;
    }
    return false;
}
exports._isTransparency = _isTransparency;
