export interface processInfo {
    ExeFile: string;
    ParentId: number;
    Id: number;
    cntThreads: number;
    pcPriClassBase: number;
    [index: string]: string | number;
}
/**
 * 进程ID取运行路径
 * @param ProcessId 进程id
 */
export declare function QueryFullProcessImageName(ProcessId: number): string;
/**
 * 系统盘符转换为DOS设备描述
 * @param Drive 盘符,例如:C,D
 */
export declare function DriveToDosDevice(Drive: string): string;
/**
 * 获取所有盘符
 */
export declare function GetDrives(): string[];
/**
 * 进程快照
 * @returns
 */
export declare function ProcessSnapshot(): processInfo[] | false;
interface PS_CB {
    (p: processInfo): void;
}
/**
 * 进程快照 回调形式
 * @returns
 */
export declare function ProcessSnapshot_cb(callback: PS_CB): any;
export interface EnumProcessesCallback {
    (processId: number): any;
}
/**
 * 提供了进程快照和基于快照的进程树，内部做了一个完整的循环。
 * 如果要对ProcessId进程处理或操作。建议使用EnumProcesses，因为只做了一次循环。
 * 回调传回Id可以对Id做更多操作。但快照有个好处,没有权限方面限制。
 * @function 枚举进程,Psapi.dll->EnumProcesses
 * @param callback EnumProcessCallback:(processId:number):any
 * @returns 如果函数调用成功返回真
 * @returns Returns true if the function call succeeds
 */
export declare function EnumProcesses(callback: EnumProcessesCallback): any;
/**
 * 取当前进程ID，但并不确定用在electron上是什么效果。
 */
export declare function GetCurrentProcessId(): any;
/**
 * 进程ID取文件路径
 * @param ProcessId
 * @returns
 */
export declare function _filePathFromProcessId(ProcessId: number): string;
/**
 * 生成进程树
 * @returns
 */
export declare function _processTree(): any;
export {};
